<template>
  <v-dialog
    v-model="open"
    transition="dialog-bottom-transition"
    width="40rem"
    persistent
    @keydown.esc="resetDialog"
  >
    <v-card>
      <toolbar
        :title="id ? 'Editar' : 'Criar'"
        :description-btn="'Salvar'"
        @save="save"
        @resetDialog="resetDialog"
      />
      <v-container>
        <v-form ref="formDeveloperRegistration" lazy-validation>
          <v-row dense class="mx-6 mt-2">
            <v-col cols="12" md="8">
              <v-text-field
                v-model="copyDeveloper.name"
                dense
                autofocus
                required
                :rules="nameRules"
                :counter="maxLength"
                solo
                placeholder="Nome *"
              />
            </v-col>
            <v-col cols="12" md="4" style="display: inline-flex">
              <date-picker
                v-model="copyDeveloper.birthdate"
                v-mask="'##/##/####'"
                value-type="format"
                format="DD/MM/YYYY"
                placeholder="Data nascimento"
                :disabled-date="disabledRangeDate"
              />
            </v-col>
            <v-col cols="12" md="6">
              <v-autocomplete
                v-model="copyDeveloper.sex"
                item-text="description"
                item-value="id"
                :items="listSex"
                dense
                required
                :rules="rules"
                solo
              />
            </v-col>
            <v-col cols="12" md="6">
              <v-text-field
                v-model="copyDeveloper.age"
                dense
                type="Number"
                solo
                required
                :rules="ageRules"
                placeholder="Idade"
              />
            </v-col>
            <v-col cols="12">
              <v-text-field
                v-model="copyDeveloper.hobby"
                dense
                required
                :counter="maxLength"
                :rules="hobbyRules"
                solo
                placeholder="Hobby"
              />
            </v-col>
          </v-row>
        </v-form>
      </v-container>
    </v-card>
  </v-dialog>
</template>
<script>
import moment from 'moment'
import Util from '../../../util/index'
import DatePicker from 'vue2-datepicker'
import 'vue2-datepicker/index.css'
import './index.css'
import Toolbar from '../../../components/toolbar/index.vue'
import { mapGetters } from 'vuex'
import { mask } from 'vue-the-mask'

export default {
  directives: { mask },

  components: {
    DatePicker,
    Toolbar
  },
  props: {
    open: {
      type: Boolean,
      default: false
    },
    id: {
      type: String,
      default: ''
    }
  },
  data() {
    return {
      maxLength: 30,
      maxDate: moment(new Date()).format('YYYY-MM-DD'),
      minDate: moment().subtract(120, 'year').format('YYYY-MM-DD'),
      copyDeveloper: {
        name: '',
        sex: '',
        birthdate: moment().subtract(20, 'year').format('YYYY-MM-DD'),
        age: null,
        hobby: ''
      },
      rules: [
        v => v != '' || 'Campo obrigatório!',
        v => v != null || 'Campo obrigatório!'
      ],
      nameRules: [
        v => v != '' || 'Campo obrigatório!',
        v => v != null || 'Campo obrigatório!',
        v => v.length <= 30 || 'Nome muito grande!'
      ],
      hobbyRules: [
        v => v != '' || 'Campo obrigatório!',
        v => v != null || 'Campo obrigatório!',
        v => v.length <= 50 || 'Nome muito grande!'
      ],
      ageRules: [
        v => v != '' || 'Campo obrigatório!',
        v => v != null || 'Campo obrigatório!',
        v => v <= 120 || 'Idade inválida!',
        v => v >= 0 || 'Idade inválida!'
      ]
    }
  },

  computed: {
    ...mapGetters(['getDeveloper'])
  },

  async mounted() {
    if (this.id) {
      this.copyDeveloper = Util.copy(this.getDeveloper)
      this.copyDeveloper.birthdate = this.copyDeveloper.birthdate
        ? moment(this.copyDeveloper.birthdate, 'YYYY-MM-DD').format(
            'DD/MM/YYYY'
          )
        : ''
    }
  },

  methods: {
    disabledRangeDate(date) {
      const today = new Date()
      const limit = moment(new Date()).subtract(120, 'year')
      today.setHours(0, 0, 0, 0)

      return date < limit || date > today
    },

    async save() {
      if (this.$refs.formDeveloperRegistration.validate()) {
        await this.convertDate()
        if (this.copyDeveloper._id) {
          const input = {
            _id: this.copyDeveloper._id,
            name: this.copyDeveloper.name,
            sex: this.copyDeveloper.sex,
            age: this.copyDeveloper.age,
            hobby: this.copyDeveloper.hobby,
            birthdate: this.copyDeveloper.birthdate
          }
          await this.$store.dispatch('actionEdit', input).then(() => {
            this.$emit('freshList')
            this.$emit('close')
            this.createAlert('success', 'Desenvolvedor salvo!')
          })
        } else {
          await this.$store
            .dispatch('actionCreate', this.copyDeveloper)
            .then(() => {
              this.$emit('freshList')
              this.$emit('close')
              this.createAlert('success', 'Desenvolvedor criado!')
            })
        }
      } else {
        this.createAlert('red', 'Preencha todos os campos corretamente!')
      }
    },

    convertDate() {
      this.copyDeveloper.birthdate = this.copyDeveloper.birthdate
        ? moment(this.copyDeveloper.birthdate, 'DD/MM/YYYY').format(
            'YYYY-MM-DD'
          )
        : ''
    },

    resetDialog() {
      this.$emit('close')
      this.copyDeveloper = {
        name: '',
        sex: '',
        birth_date: '',
        age: null,
        hobby: ''
      }
      this.$refs.formDeveloperRegistration.reset()
    }
  }
}
</script>
